import * as codebuild from 'aws-cdk-lib/aws-codebuild';
import * as iam from 'aws-cdk-lib/aws-iam';
import * as pipelines from 'aws-cdk-lib/pipelines';
import { IResourceProvider, ResourceContext } from '../common';
export interface RuntimeVersionOptions {
    readonly java?: string;
    readonly php?: string;
    readonly ruby?: string;
    readonly golang?: string;
    readonly python?: string;
    readonly nodejs?: string;
    readonly dotnet?: string;
}
export interface BuildOptions {
    readonly runTimeVersions?: RuntimeVersionOptions;
    readonly codeBuildDefaults?: pipelines.CodeBuildOptions;
}
export interface ICIDefinition {
    provideBuildSpec(): codebuild.BuildSpec;
    append(partialBuildSpec: codebuild.BuildSpec): void;
    provideCodeBuildDefaults(): pipelines.CodeBuildOptions;
    additionalPolicyStatements(policyStatements: iam.PolicyStatement[]): void;
}
/**
 * Provides CodeBuild BuildSpec for the Synth Step
 */
export declare class CIDefinitionProvider implements IResourceProvider {
    provide(context: ResourceContext): any;
}
export declare class BaseCIDefinition implements ICIDefinition {
    private buildSpec;
    private buildOptions;
    constructor(buildSpec: codebuild.BuildSpec, buildOptions: pipelines.CodeBuildOptions);
    provideBuildSpec(): codebuild.BuildSpec;
    provideCodeBuildDefaults(): pipelines.CodeBuildOptions;
    append(partialBuildSpec: codebuild.BuildSpec): void;
    additionalPolicyStatements(policyStatements: iam.PolicyStatement[]): void;
    appendCodeBuildOptions(codeBuildOptions: pipelines.CodeBuildOptions): void;
}
